import { DkColumnMesh } from './dk-column-mesh';
import { DkGutterMeshSlot, DkColumnMeshSlot, DkMeshSlot } from './dk-column-mesh-slot';
import { DkSlotPlacement } from '../common/dk-slot-placement';
import { DisplayStatus } from './dk-column-def';
export declare class PreOrderDkColumnMesh extends DkColumnMesh {
    private rightOuterGutterSlot;
    constructor(rightOuterGutterSlot: DkGutterMeshSlot, belongToGroupId: string);
    isComplementGutter(gutter: DkGutterMeshSlot): boolean;
    getContentMeshTemplate(displayStatus: DisplayStatus, outerSlots: DkColumnMeshSlot[]): string;
    getHeaderMeshTemplate(displayStatus: DisplayStatus, outerSlots: DkColumnMeshSlot[], scrollbarGapSlot: DkColumnMeshSlot): string;
    getEdgeGutters(displayStatus: DisplayStatus, isComplementGutter: boolean): DkGutterMeshSlot[];
    /**
     * Source column slot will be place before the destination gutter slot.
     *
     * Source and destination slots must live in the same instance list.
     *
     * @param {DkColumnMeshSlot} sourceColumnSlot The source, data or group, column slot.
     * @param {DkMeshSlot} destinationGutterSlot The destination gutter.
     *
     * @returns {boolean} True if the movement was done successfully.
     */
    swapToGutterSlotNode(sourceColumnSlot: DkColumnMeshSlot, destinationGutterSlot: DkMeshSlot): boolean;
    calculateContainerWidth(displayStatus: DisplayStatus, outerSlots: DkColumnMeshSlot[], scrollbarGapSlot: DkColumnMeshSlot): number;
    setColumnMeshSlotPlacement(displayStatus: DisplayStatus, greatestHeight: number, outerSlots: DkColumnMeshSlot[], scrollbarGapSlot: DkColumnMeshSlot): DkSlotPlacement;
    protected calculateColumnSlotsMeshContainerWidth(displayStatus: DisplayStatus): number;
    protected calculateColumnMeshSlotsPlacement(displayStatus: DisplayStatus, currentHeight: number, gridColumnStart: number, gridRowStart: number): number;
    protected getColumnSlotsTemplate(displayStatus: DisplayStatus): string;
    protected setComplementDikeGutterSlot(displayStatus: DisplayStatus): void;
}
