import { AfterContentInit, QueryList, TemplateRef } from '@angular/core';
import { BooleanInput, NumberInput } from '@angular/cdk/coercion';
import { DisplayStatus, GetterFn, DkColumnDataType, SetterFn, ColumnAlignment } from '../dk-column-def';
import { DkFilter } from '../../filtering/dk-filter.model';
import { DkGridPanel } from '../../panels/dk-grid-panels';
import { EditionFieldSettings } from '../../editing/dk-edition.model';
import { CustomFilterConditionInstance } from '../../filtering/dk-filter-factory.service';
import { DkGridFactoryColumns } from '../dk-grid-factory-columns.service';
import * as i0 from "@angular/core";
export declare class DkGridColumnComponent<T extends object, R extends string | number | Date | boolean | null | undefined> implements AfterContentInit {
    private gridFactoryColumns;
    slotId: string;
    fieldName: string;
    headerText: string;
    headerTooltip: string;
    dataType: DkColumnDataType;
    get order(): number;
    set order(value: any);
    private _order;
    static ngAcceptInputType_order: NumberInput;
    get width(): number;
    set width(value: any);
    private _width;
    static ngAcceptInputType_width: NumberInput;
    get minWidth(): number;
    set minWidth(value: any);
    private _minWidth;
    static ngAcceptInputType_minWidth: NumberInput;
    get maxWidth(): number;
    set maxWidth(value: any);
    private _maxWidth;
    static ngAcceptInputType_maxWidth: NumberInput;
    contentAlign: ColumnAlignment;
    get draggable(): boolean;
    set draggable(value: any);
    private _draggable;
    static ngAcceptInputType_draggable: BooleanInput;
    get locked(): boolean;
    set locked(value: any);
    private _locked;
    static ngAcceptInputType_locked: BooleanInput;
    get resizable(): boolean;
    set resizable(value: any);
    private _resizable;
    static ngAcceptInputType_resizable: BooleanInput;
    get visible(): boolean;
    set visible(value: any);
    private _visible;
    static ngAcceptInputType_visible: BooleanInput;
    get sortable(): boolean;
    set sortable(value: any);
    private _sortable;
    static ngAcceptInputType_sortable: BooleanInput;
    get filterable(): boolean;
    set filterable(value: any);
    private _filterable;
    static ngAcceptInputType_filterable: BooleanInput;
    get editable(): boolean;
    set editable(value: any);
    private _editable;
    static ngAcceptInputType_editable: BooleanInput;
    get groupable(): boolean;
    set groupable(value: any);
    private _groupable;
    static ngAcceptInputType_groupable: BooleanInput;
    get displayMenu(): boolean;
    set displayMenu(value: any);
    private _displayMenu;
    static ngAcceptInputType_displayMenu: BooleanInput;
    filter: DkFilter[];
    customFilterConditions: CustomFilterConditionInstance<T>;
    panel: DkGridPanel;
    displayOn: DisplayStatus;
    displayStatus: DisplayStatus;
    getValue: GetterFn<T, R>;
    setValue: SetterFn<T, R>;
    editionSettings: EditionFieldSettings;
    editionTemplate: TemplateRef<any> | null | undefined;
    displayTemplate: TemplateRef<any> | null | undefined;
    /**
     * DikeGridColumn component is used to create groups of columns.
     * Columns of type DikeGridColumn are grouped into a column of type DikeGridColumn.
     *
     * Retrieving children columns
     *
     * We use the @ContentChildren(DkGridColumnComponent) decorator inside DkGridColumnComponent class to query children columns.
     * This decorator has a particular behavior:
     *    1. As we know parent components, first, construct their children's components.  Therefore, traversing will be the first-depth type.
     *    2. ngAfterContentInit life-cycle hook will be called for the deepest children first and then for their parents.
     *    3. When the query is run, it retrieves the current column itself and its children's columns.
     */
    childColumns: QueryList<DkGridColumnComponent<T, R>>;
    constructor(gridFactoryColumns: DkGridFactoryColumns<T>);
    ngAfterContentInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridColumnComponent<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkGridColumnComponent<any, any>, "dk-grid-column", ["dkgColumn"], { "fieldName": "fieldName"; "headerText": "headerText"; "headerTooltip": "headerTooltip"; "dataType": "dataType"; "order": "order"; "width": "width"; "minWidth": "minWidth"; "maxWidth": "maxWidth"; "contentAlign": "contentAlign"; "draggable": "draggable"; "locked": "locked"; "resizable": "resizable"; "visible": "visible"; "sortable": "sortable"; "filterable": "filterable"; "editable": "editable"; "groupable": "groupable"; "displayMenu": "displayMenu"; "filter": "filter"; "customFilterConditions": "customFilterConditions"; "panel": "panel"; "displayOn": "displayOn"; "displayStatus": "displayStatus"; "getValue": "getValue"; "setValue": "setValue"; "editionSettings": "editionSettings"; "editionTemplate": "editionTemplate"; "displayTemplate": "displayTemplate"; }, {}, ["childColumns"], never, false>;
}
