import { OnDestroy } from '@angular/core';
import { DkConfig } from '../grid/dk-config';
import { DkDataColumn, DkGutterColumn, DkScrollbarGapColumn, DkRowIndexColumn, DkGroupColumn } from './dk-column';
import { DkColumnMeshSlot } from './dk-column-mesh-slot';
import { DkGridPanel } from '../panels/dk-grid-panels';
import { DkDataColumnDef, DkGroupColumnDef, DkColumnDef, DkColumnDataType } from './dk-column-def';
import { DkGridColumnComponent } from './dk-grid-column/dk-grid-column.component';
import { DkGridFilterConfig } from '../filtering/dk-grid-filter-config.service';
import * as i0 from "@angular/core";
export declare class DkGridFactoryColumns<T extends object> implements OnDestroy {
    private dikeConfig;
    private gridFilterConfig;
    rootColumns: DkColumnDef[];
    constructor(dikeConfig: DkConfig, gridFilterConfig: DkGridFilterConfig<T>);
    ngOnDestroy(): void;
    createDikeGutterColumn(panel: DkGridPanel, fieldName: string): DkGutterColumn;
    createDikeRowIndexColumn(panel: DkGridPanel, width?: number): DkRowIndexColumn;
    createDikeScrollbarGapColumn(panel: DkGridPanel, width: number): DkScrollbarGapColumn;
    createDikeDataColumn(fieldName: string, headerText: string, dataType: DkColumnDataType): DkDataColumn<T, string | number | Date | boolean | null | undefined>;
    createDikeGroupColumn(groupName: string, headerText: string): DkGroupColumn;
    cloneDikeDataColumn(dikeColumn: DkDataColumn<T, string | number | Date | boolean | null | undefined>): DkDataColumn<T, string | number | Date | boolean | null | undefined>;
    createDikeDataColumnDefFromUIColumn(column: DkGridColumnComponent<T, string | number | Date | boolean | null | undefined>): DkDataColumnDef<T, string | number | Date | boolean | null | undefined>;
    createDikeGroupColumnDefFromUIColumn(column: DkGridColumnComponent<T, string | number | Date | boolean | null | undefined>): DkGroupColumnDef;
    createDikeDataColumnDefFromColumnSlot(columnSlot: DkColumnMeshSlot): DkDataColumnDef<T, string | number | Date | boolean | null | undefined>;
    createDikeGroupColumnDefFromColumnSlot(columnSlot: DkColumnMeshSlot): DkGroupColumnDef;
    createDikeGroupColumnDefFromGroupColumnDef(column: DkGroupColumnDef): DkGroupColumnDef;
    cloneDikeGroupColumnDef(column: DkGroupColumnDef): DkGroupColumnDef;
    cloneDikeDataColumnDef(column: DkDataColumnDef<T, string | number | Date | boolean | null | undefined>): DkDataColumnDef<T, string | number | Date | boolean | null | undefined>;
    removeRootColumnFromArray(slotId: string): DkColumnDef;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridFactoryColumns<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridFactoryColumns<any>>;
}
