import { BehaviorSubject, Observable } from 'rxjs';
import { DkGridPanel, DkGroupPanel } from '../panels/dk-grid-panels';
import { DkColumnDef, DkDataColumnDef, DkGroupColumnDef } from './dk-column-def';
import { DkColumnMeshSlot } from './dk-column-mesh-slot';
import { DkColumnStructure } from './dk-column-structure';
import { GroupDkColumnMesh } from './dk-column-mesh-group';
import { DkConfig } from '../grid/dk-config';
import { DkGridConfig } from '../grid/dk-grid-config.service';
import { DkGridFactoryMeshSlots } from './dk-grid-factory-mesh-slots.service';
import { DkGridFactoryColumns } from './dk-grid-factory-columns.service';
import { DkGridFilterConfig } from '../filtering/dk-grid-filter-config.service';
import { DkSortDispatcher } from '../sorting/dk-sort-dispatcher.service';
import { DkGridEditionConfig } from '../editing/dk-grid-edition-config.service';
export interface DkDataColumnDefLinkTo<T extends object> {
    clonedDataColumnDef: DkDataColumnDef<T, string | number | Date | boolean | null | undefined>;
    leafDataColumnDef: DkDataColumnDef<T, string | number | Date | boolean | null | undefined>;
    branch: DkColumnDef;
    leafParent: DkGroupColumnDef;
}
export declare type DataBranchType = 'groupable' | 'nonGroupable';
export declare class DkGroupColumnStructure<T extends object> extends DkColumnStructure<T, DkGroupPanel> {
    dataColumnDefIdentities: Map<string, DkDataColumnDefLinkTo<T>>;
    protected gridTemplateColumnsGroupSubject: BehaviorSubject<string>;
    constructor(panel: DkGroupPanel, dikeConfig: DkConfig, gridConfig: DkGridConfig, gridFactoryColumns: DkGridFactoryColumns<T>, gridFactoryMeshSlots: DkGridFactoryMeshSlots<T>, gridFilterConfig: DkGridFilterConfig<T>, sortDispatcher: DkSortDispatcher<T>, gridEditionConfig: DkGridEditionConfig<T>);
    get onGridTemplateColumnsGroupChanged$(): Observable<string>;
    addColumn(dataColumn: DkDataColumnDef<T, string | number | Date | boolean | null | undefined>): DkColumnMeshSlot;
    addColumnsFromPanel(columns: DkDataColumnDef<T, string | number | Date | boolean | null | undefined>[]): void;
    cloneColumnSlotForMoving(columnSlot: DkColumnMeshSlot, destinationSlot: DkColumnStructure<T, DkGridPanel>): DkColumnDef;
    removeClonedColumnSlot(columnSlot: DkColumnMeshSlot, notifyChanges?: boolean): DkColumnDef;
    protected createChildrenList(panel: DkGroupPanel, belongToGroupId: string): GroupDkColumnMesh;
    protected getOuterSlots(): DkColumnMeshSlot[];
    protected changeGridTemplateColumns(): void;
}
