import { OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DkGridRowHeader, DkGridRowFilter, DkGridRowContent } from './dk-grid-content.model';
import { DkConfig } from '../grid/dk-config';
import { DkGridFilterConfig } from '../filtering/dk-grid-filter-config.service';
import { DkContentPanelDispatcher } from './dk-content-panel-dispatcher.service';
import * as i0 from "@angular/core";
export declare class DkGridContentStructure<T extends object> implements OnDestroy {
    private dikeConfig;
    private gridHeaderRowHeight;
    private gridFilterRowHeight;
    private gridContentRowHeight;
    private gridFilterConfig;
    private contentPanelDispatcher;
    private gridContentMesh;
    private headerRowHeightSubject;
    private filterRowHeightSubject;
    private contentRowHeightSubject;
    private contentViewPortHeightSubject;
    private horizontalScrollHeightSubject;
    private updateCdkVirtualScrollViewport;
    private gridTemplateColumnsSubject;
    private gridTemplateRowsSubject;
    private gridHeaderTemplateRowsSubject;
    private unsubscribeAll;
    constructor(dikeConfig: DkConfig, gridHeaderRowHeight: number, gridFilterRowHeight: number, gridContentRowHeight: number, gridFilterConfig: DkGridFilterConfig<T>, contentPanelDispatcher: DkContentPanelDispatcher<T>);
    ngOnDestroy(): void;
    get onGridTemplateColumnsChanged$(): Observable<string>;
    get onGridTemplateRowsChanged$(): Observable<string>;
    get onGridHeaderTemplateRowsChanged$(): Observable<string>;
    get onHeaderRowHeightChanged$(): Observable<DkGridRowHeader>;
    get onFilterRowHeightChanged$(): Observable<DkGridRowFilter>;
    get onContentRowHeightChanged$(): Observable<DkGridRowContent>;
    get onContentViewPortHeightChanged$(): Observable<number>;
    get onHorizontalScrollHeightChanged$(): Observable<number>;
    get onUpdateCdkScrollViewport$(): Observable<void>;
    get headerRowHeight(): number;
    set headerRowHeight(height: number);
    get filterRowHeight(): number;
    set filterRowHeight(height: number);
    get contentRowHeight(): number;
    set contentRowHeight(height: number);
    setContentViewPortHeight(height: number): void;
    getContentViewPortHeight(): number;
    setHorizontalScrollHeight(height: number): void;
    private createGridRowHeader;
    private createGridRowFilter;
    private createGridRowContent;
    private changeHeaderRowHeight;
    private changeFilterRowHeight;
    private changeContentRowHeight;
    private changeContentViewPortHeight;
    private changeHorizontalScrollHeight;
    private changeCdkScrollViewport;
    private changeGridTemplateRows;
    private changeGridHeaderTemplateRows;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridContentStructure<any>, [null, { optional: true; }, { optional: true; }, { optional: true; }, null, null]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridContentStructure<any>>;
}
