import { OnInit, AfterViewInit } from '@angular/core';
import { MatTab } from '@angular/material/tabs';
import { Observable } from 'rxjs';
import { DkContextMenuRef } from '../dk-context-menu-ref';
import { DkColumnFilterComponent } from '../../filtering/dk-column-filter/dk-column-filter.component';
import { DkColumnMeshSlot } from '../../columns/dk-column-mesh-slot';
import { DkGridFilterConfig } from '../../filtering/dk-grid-filter-config.service';
import { DkGridConfig } from '../../grid/dk-grid-config.service';
import { DkSortDispatcher } from '../../sorting/dk-sort-dispatcher.service';
import { DkDataSourceDispatcher } from '../../datasource/dk-data-source-dispatcher.service';
import * as i0 from "@angular/core";
export declare class DkColumnContextMenuComponent<T extends object> implements OnInit, AfterViewInit {
    private gridConfig;
    private gridFilterConfig;
    private sortDispatcher;
    private dataSourceDispatcher;
    filterTab: MatTab;
    columnFiltering: DkColumnFilterComponent<T>;
    columnSlot: DkColumnMeshSlot;
    selfContextRef: DkContextMenuRef;
    isFilterable: boolean;
    displayFilterOptions: boolean;
    contentHeight: number;
    tabHeader: number;
    padding: number;
    horizontalScrolling: number;
    customScrollbars: boolean;
    onDemandFilter$: Observable<boolean>;
    onAllowSorting$: Observable<boolean>;
    /***********************************************/
    disableSortPagination$: Observable<boolean>;
    /***********************************************/
    private titleHeight;
    private filterOptionsHeight;
    constructor(data: any, contextMenuRef: DkContextMenuRef, gridConfig: DkGridConfig, gridFilterConfig: DkGridFilterConfig<T>, sortDispatcher: DkSortDispatcher<T>, dataSourceDispatcher: DkDataSourceDispatcher<T>);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    addFilterCondition(): void;
    canAddFilterCondition(): boolean;
    clearFilter(): void;
    applyFilterOnDemand(): void;
    calculateContentHeight(filterOptionsVisible: boolean): number;
    onMoveColumn(result: boolean): void;
    onSelectedTabChange(): void;
    private filterOptionsVisibility;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkColumnContextMenuComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkColumnContextMenuComponent<any>, "dk-column-context-menu", never, {}, {}, never, never, false>;
}
