import { BehaviorSubject, Subscription, Observable } from "rxjs";
import { DkDataSource } from "./dk-datasource";
import { DkGridDataRowEntry } from '../rows/dk-grid-row-entry';
export declare abstract class DkDecoratorDataSource<T extends object> extends DkDataSource<DkGridDataRowEntry<T>> {
    protected dikeDataSource: DkDataSource<DkGridDataRowEntry<T>>;
    protected changeSubscription: Subscription;
    protected decoratorSubject: BehaviorSubject<DkGridDataRowEntry<T>[]>;
    constructor(dikeDataSource: DkDataSource<DkGridDataRowEntry<T>>);
    get data(): DkGridDataRowEntry<T>[];
    set data(value: DkGridDataRowEntry<T>[]);
    connect(): Observable<DkGridDataRowEntry<T>[]>;
    disconnect(): void;
    reconnect(): void;
    dispose(releaseSource: boolean): void;
    protected abstract setChangeSubscription(): void;
    private changeDecoratorData;
}
