import { OnDestroy } from '@angular/core';
import { FieldUpdate, RowStatus } from '../editing/dk-edition.model';
import { DkGridDataRowEntry } from '../rows/dk-grid-row-entry';
import { DkDataSourceDispatcher } from './dk-data-source-dispatcher.service';
import { DkGeneralNotifier } from '../common/dk-general-notifier.service';
import * as i0 from "@angular/core";
export declare class DkGridDataStore<T extends object> implements OnDestroy {
    private dataSourceDispatcher;
    private generalNotifier;
    private gridDataSource;
    private rowsInEdition;
    private changeDataSourceSubscription;
    constructor(dataSourceDispatcher: DkDataSourceDispatcher<T>, generalNotifier: DkGeneralNotifier);
    ngOnDestroy(): void;
    updateField(rowId: number, rowStatus: RowStatus, field: FieldUpdate<T, string | number | Date | boolean | null | undefined>, timestamp: number): void;
    updateRow(rowId: number, rowStatus: RowStatus, fields: FieldUpdate<T, string | number | Date | boolean | null | undefined>[], timestamp: number): void;
    deleteRow(rowId: number, timestamp: number): void;
    setEditionRowState(row: DkGridDataRowEntry<T>): void;
    cancelEditionRowState(row: DkGridDataRowEntry<T>): void;
    filterRows(compareFn: (row: DkGridDataRowEntry<T>) => boolean): DkGridDataRowEntry<T>[];
    getRow(rowId: number): DkGridDataRowEntry<T>;
    getRowsInEditionState(): DkGridDataRowEntry<T>[];
    getDeletedRows(): DkGridDataRowEntry<T>[];
    getUpdatedRows(): DkGridDataRowEntry<T>[];
    sendChanges(): void;
    releaseRowsInEdition(): void;
    private setChangeDataSourceSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridDataStore<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridDataStore<any>>;
}
