import { Observable } from 'rxjs';
import { DkGridGroupRowEntry, DkGridRowEntry } from '../rows/dk-grid-row-entry';
import { DkGroupedContentDataSource } from './dk-grouped-content-datasource';
import { DkDataSource, DkGridDataSource } from './dk-datasource';
import { DkRowGroupingDispatcher } from '../row-grouping/dk-row-grouping-dispatcher.service';
import { DkDataSourceDispatcher } from './dk-data-source-dispatcher.service';
import { DkGeneralNotifier } from '../common/dk-general-notifier.service';
import { DkGridSelectionConfig } from '../selection/dk-grid-selection-config.service';
import { DkGridSelection } from '../selection/dk-grid-selection.service';
export declare const ROOT_GROUP_DATASOURCE = "root-group-datasource";
export declare class DkGroupingDataSource<T extends object> extends DkGroupedContentDataSource<T> {
    private groupRow;
    private joiningDataSource;
    private childrenGroups;
    private pushingGroupDataSubject;
    constructor(gridDataSource: DkGridDataSource<T>, groupRow: DkGridGroupRowEntry<T>, gridSelectionConfig: DkGridSelectionConfig<T>, gridSelection: DkGridSelection<T>, dataSourceDispatcher: DkDataSourceDispatcher<T>, rowGroupingDispatcher: DkRowGroupingDispatcher<T>, generalNotifier: DkGeneralNotifier);
    get onPushingDataGroupChanged$(): Observable<void>;
    get groupRowEntry(): DkGridGroupRowEntry<T>;
    disconnect(): void;
    reconnect(): void;
    dispose(releaseSource: boolean): void;
    private createChildrenDataSourceGroups;
    private isGroupLeaf;
    private isLeaf;
    private pushingGroupData;
    protected getDecoratedGridDataSource(gridDataSource: DkGridDataSource<T>): DkDataSource<DkGridRowEntry>;
    protected getDataSourceStream(): Observable<DkGridRowEntry[]>;
    protected setChangeSubscription(isReconnection?: boolean): void;
    protected getDikeDataSource(): DkDataSource<DkGridRowEntry>;
}
