import { FieldUpdate, RowStatus } from './dk-edition.model';
import { Command } from './dk-grid-commands';
import { Memento } from './dk-grid-mementos';
import { DkGridDataStore } from '../datasource/dk-grid-data-store.service';
import * as i0 from "@angular/core";
export declare class DkGridCommandFactory<T extends object> {
    private gridDataStore;
    constructor(gridDataStore: DkGridDataStore<T>);
    createUpdateFieldCommand(rowId: number, field: FieldUpdate<T, string | number | Date | boolean | null | undefined>, timestamp: number): Command;
    createUpdateRowCommand(rowId: number, fields: FieldUpdate<T, string | number | Date | boolean | null | undefined>[], timestamp: number): Command;
    createDeleteRowCommand(rowId: number, timestamp: number): Command;
    createRowMemento(rowId: number, rowStatus: RowStatus, fields: FieldUpdate<T, string | number | Date | boolean | null | undefined>[], timestamp: number): Memento;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridCommandFactory<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridCommandFactory<any>>;
}
