import { FieldUpdate } from './dk-edition.model';
import { DkGridDataStore } from '../datasource/dk-grid-data-store.service';
export interface Command {
    execute(): void;
}
export declare class UpdateFieldCommand<T extends object> implements Command {
    private gridDataStore;
    private rowId;
    private field;
    private timestamp;
    constructor(gridDataStore: DkGridDataStore<T>, rowId: number, field: FieldUpdate<T, string | number | Date | boolean | null | undefined>, timestamp: number);
    execute(): void;
}
export declare class UpdateRowCommand<T extends object> implements Command {
    private gridDataStore;
    private rowId;
    private fields;
    private timestamp;
    constructor(gridDataStore: DkGridDataStore<T>, rowId: number, fields: FieldUpdate<T, string | number | Date | boolean | null | undefined>[], timestamp: number);
    execute(): void;
}
export declare class DeleteRowCommand<T extends object> implements Command {
    private gridDataStore;
    private rowId;
    private timestamp;
    constructor(gridDataStore: DkGridDataStore<T>, rowId: number, timestamp: number);
    execute(): void;
}
