import { OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DkGridDataRowEntry } from '../rows/dk-grid-row-entry';
import { RowStatus } from './dk-edition.model';
import { DkConfig } from '../grid/dk-config';
import { DkGridEditionConfig } from './dk-grid-edition-config.service';
import { DkGridRowEditionDispatcher } from './dk-grid-row-edition-dispatcher.service';
import * as i0 from "@angular/core";
export declare class DkGridEdition<T extends object> implements OnDestroy {
    private dikeConfig;
    private gridEditionConfig;
    private rowEditionDispatcher;
    private changeEditionConfigSubscription;
    private changeRowsInEditionSetSubscription;
    constructor(dikeConfig: DkConfig, gridEditionConfig: DkGridEditionConfig<T>, rowEditionDispatcher: DkGridRowEditionDispatcher<T>);
    ngOnDestroy(): void;
    get editionRowChange(): Observable<DkGridDataRowEntry<T>>;
    get updateRowChange(): Observable<DkGridDataRowEntry<T> | DkGridDataRowEntry<T>[]>;
    get cancelRowEditionChange(): Observable<DkGridDataRowEntry<T> | DkGridDataRowEntry<T>[]>;
    get removeRowChange(): Observable<DkGridDataRowEntry<T> | DkGridDataRowEntry<T>[]>;
    get restoreRowChange(): Observable<DkGridDataRowEntry<T> | DkGridDataRowEntry<T>[]>;
    get editionFilterStateChange(): Observable<boolean>;
    get editionFilterState(): boolean;
    editRow(row: DkGridDataRowEntry<T>): void;
    updateRow(row: DkGridDataRowEntry<T>): void;
    cancelRowEdition(row: DkGridDataRowEntry<T>): void;
    removeRow(row: DkGridDataRowEntry<T>): void;
    restoreRow(row: DkGridDataRowEntry<T>): void;
    updateRowsInEdition(): void;
    removeRows(rows: DkGridDataRowEntry<T>[]): void;
    cancelRowsInEdition(): void;
    restoreRows(rows: DkGridDataRowEntry<T>[]): void;
    setEditionFilter(value: RowStatus): void;
    cancelEditionFilter(): void;
    get rowsInEdition(): DkGridDataRowEntry<T>[];
    get modifiedRows(): DkGridDataRowEntry<T>[];
    get removedRows(): DkGridDataRowEntry<T>[];
    private setChangeRowsInEditionSetSubscription;
    private setChangeEditionConfigSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridEdition<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridEdition<any>>;
}
