import { OnInit, EventEmitter, ChangeDetectorRef } from '@angular/core';
import { UntypedFormGroup, UntypedFormBuilder, UntypedFormArray, AbstractControl } from '@angular/forms';
import { MatSelectChange } from '@angular/material/select';
import { Condition } from '../dk-filter-types';
import { DkBinaryFilter, DkBinaryFilterEmission, DkFilterBehaviour } from '../dk-filter.model';
import { DkBinarySelectionModel } from '../../common/dk-selection-model';
import { CustomBinaryFilterCondition } from '../dk-binary-filter.conditions';
import { DkConfig } from '../../grid/dk-config';
import { DkGridConfig } from '../../grid/dk-grid-config.service';
import * as i0 from "@angular/core";
export declare class DkBinaryFilterComponent<T extends object> implements OnInit, DkFilterBehaviour<DkBinaryFilterEmission> {
    private dikeConfig;
    private cdr;
    private formBuilder;
    private gridConfig;
    isFilterRow: boolean;
    appliedFilter: DkBinaryFilter[];
    selectionFilterInstance: CustomBinaryFilterCondition<T>;
    onDemandFilter: boolean;
    CLEAR_FILTER: string;
    displayEmptyValuesOption: boolean;
    conditionTypes: Condition<T, string | number | boolean | null | undefined, DkBinaryFilter>[];
    options: DkBinarySelectionModel[];
    filterChange: EventEmitter<DkBinaryFilterEmission>;
    binaryFilterForm: UntypedFormGroup;
    matSelectPanelClass: string;
    constructor(dikeConfig: DkConfig, cdr: ChangeDetectorRef, formBuilder: UntypedFormBuilder, gridConfig: DkGridConfig);
    ngOnInit(): void;
    get conditions(): UntypedFormArray;
    addCondition(): void;
    clear(): void;
    applyFilter(): void;
    onConditionTypeChange(event: MatSelectChange, conditionGroup: AbstractControl): void;
    onBinaryOptionChange(): void;
    onIncludeEmptyValuesChange(): void;
    onOptionChange(event: MatSelectChange): void;
    isFilterApplied(): boolean;
    private createForm;
    private createConditionGroup;
    private addValueControl;
    private hasEmptyCondition;
    private emitValues;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkBinaryFilterComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkBinaryFilterComponent<any>, "dk-binary-filter", never, { "isFilterRow": "isFilterRow"; "appliedFilter": "appliedFilter"; "selectionFilterInstance": "selectionFilterInstance"; "onDemandFilter": "onDemandFilter"; }, {}, never, never, false>;
}
