import { OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DkGridDataRowEntry } from '../rows/dk-grid-row-entry';
import { DkFilterable } from './dk-filter.model';
import { DkGridFilterConfig } from './dk-grid-filter-config.service';
import { DkFilterDispatcher } from './dk-filter-dispatcher.service';
import { DkDataSourceDispatcher } from '../datasource/dk-data-source-dispatcher.service';
import * as i0 from "@angular/core";
export declare class DkGridFilter<T extends object> implements OnDestroy {
    private gridFilterConfig;
    private filterDispatcher;
    private dataSourceDispatcher;
    private gridDataSource;
    private editionFiltering;
    private changeDataSourceSubscription;
    constructor(gridFilterConfig: DkGridFilterConfig<T>, filterDispatcher: DkFilterDispatcher<T>, dataSourceDispatcher: DkDataSourceDispatcher<T>);
    ngOnDestroy(): void;
    get registerFilterableChange(): Observable<DkFilterable<T>>;
    get deregisterFilterableChange(): Observable<DkFilterable<T>>;
    get filterChange(): Observable<DkFilterable<T>>;
    get editionFilterChange(): Observable<DkFilterable<T>>;
    get clearFilterChange(): Observable<void>;
    get clearEditionFilterChange(): Observable<void>;
    get filterables(): Map<string, DkFilterable<T>>;
    clearFilter(): void;
    isFilterApplied(): boolean;
    getFilteredRows(): DkGridDataRowEntry<T>[];
    private setChangeDataSourceSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridFilter<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridFilter<any>>;
}
