import { OnInit, EventEmitter, AfterViewInit, ChangeDetectorRef } from '@angular/core';
import { UntypedFormGroup, UntypedFormBuilder } from '@angular/forms';
import { MatSelectionList } from '@angular/material/list';
import { MatSelect, MatSelectChange } from '@angular/material/select';
import { Condition } from '../dk-filter-types';
import { DkNumericFilterEmission, DkFilterBehaviour, DkNumericFilter } from '../dk-filter.model';
import { DkNumericSelectionModel } from '../../common/dk-selection-model';
import { CustomMultipleNumericFilterCondition } from '../dk-multiple-numeric-filter.condition';
import { DkGridConfig } from '../../grid/dk-grid-config.service';
import { DkConfig } from '../../grid/dk-config';
import * as i0 from "@angular/core";
export declare class DkMultipleNumericFilterComponent<T extends object> implements OnInit, AfterViewInit, DkFilterBehaviour<DkNumericFilterEmission> {
    private dikeConfig;
    private cdr;
    private formBuilder;
    private gridConfig;
    isFilterRow: boolean;
    appliedFilter: DkNumericFilter[];
    selectionFilterInstance: CustomMultipleNumericFilterCondition<T>;
    onDemandFilter: boolean;
    selectionList: MatSelectionList;
    select: MatSelect;
    conditionTypes: Condition<T, number | null | undefined, DkNumericFilter>[];
    options: DkNumericSelectionModel[];
    filterChange: EventEmitter<DkNumericFilterEmission>;
    multipleNumericFilterForm: UntypedFormGroup;
    matSelectPanelClass: string;
    private EMPTY_VALUES;
    CLEAR_SELECTION: DkNumericSelectionModel;
    constructor(dikeConfig: DkConfig, cdr: ChangeDetectorRef, formBuilder: UntypedFormBuilder, gridConfig: DkGridConfig);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    addCondition(): void;
    clear(): void;
    applyFilter(): void;
    onConditionTypeChange(): void;
    onSelectedOptionChange(): void;
    isFilterApplied(): boolean;
    onSelectAllOptionsChange(): void;
    isAllSelectedControlChecked(): boolean;
    isAllSelectedControlIndeterminate(): boolean;
    isAllSelected(): boolean;
    toggleSet(): void;
    onOptionChange(event: MatSelectChange): void;
    private createForm;
    private createConditionGroup;
    private getOptionsFromFilter;
    private addEmptyOption;
    private emitValues;
    private getFilterToApply;
    private getNumericFilterElement;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkMultipleNumericFilterComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkMultipleNumericFilterComponent<any>, "dk-multiple-numeric-filter", never, { "isFilterRow": "isFilterRow"; "appliedFilter": "appliedFilter"; "selectionFilterInstance": "selectionFilterInstance"; "onDemandFilter": "onDemandFilter"; }, {}, never, never, false>;
}
