import { OnInit, AfterViewInit, EventEmitter, ChangeDetectorRef } from '@angular/core';
import { UntypedFormGroup, UntypedFormBuilder } from '@angular/forms';
import { MatSelectionList } from '@angular/material/list';
import { MatSelect, MatSelectChange } from '@angular/material/select';
import { DkFilterBehaviour, DkTextFilterEmission, DkTextFilter } from '../dk-filter.model';
import { DkTextSelectionModel } from '../../common/dk-selection-model';
import { Condition } from '../dk-filter-types';
import { CustomMultipleTextFilterCondition } from '../dk-multiple-text-filter.conditions';
import { DkConfig } from '../../grid/dk-config';
import { DkGridConfig } from '../../grid/dk-grid-config.service';
import * as i0 from "@angular/core";
export declare class DkMultipleTextFilterComponent<T extends object> implements OnInit, AfterViewInit, DkFilterBehaviour<DkTextFilterEmission> {
    private dikeConfig;
    private cdr;
    private formBuilder;
    private gridConfig;
    isFilterRow: boolean;
    appliedFilter: DkTextFilter[];
    selectionFilterInstance: CustomMultipleTextFilterCondition<T>;
    onDemandFilter: boolean;
    selectionList: MatSelectionList;
    select: MatSelect;
    isCaseSensitive: boolean;
    conditionTypes: Condition<T, string | null | undefined, DkTextFilter>[];
    options: DkTextSelectionModel[];
    filterChange: EventEmitter<DkTextFilterEmission>;
    multipleTextFilterForm: UntypedFormGroup;
    matSelectPanelClass: string;
    private EMPTY_VALUES;
    CLEAR_SELECTION: DkTextSelectionModel;
    constructor(dikeConfig: DkConfig, cdr: ChangeDetectorRef, formBuilder: UntypedFormBuilder, gridConfig: DkGridConfig);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    addCondition(): void;
    clear(): void;
    applyFilter(): void;
    onConditionTypeChange(): void;
    onSelectedOptionChange(): void;
    isFilterApplied(): boolean;
    onSelectAllOptionsChange(): void;
    isAllSelectedControlChecked(): boolean;
    isAllSelectedControlIndeterminate(): boolean;
    isAllSelected(): boolean;
    toggleSet(): void;
    onOptionChange(event: MatSelectChange): void;
    private createForm;
    private createConditionGroup;
    private getOptionsFromFilter;
    private addEmptyOption;
    private emitValues;
    private getFilterToApply;
    private getNumericFilterElement;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkMultipleTextFilterComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkMultipleTextFilterComponent<any>, "dk-multiple-text-filter", never, { "isFilterRow": "isFilterRow"; "appliedFilter": "appliedFilter"; "selectionFilterInstance": "selectionFilterInstance"; "onDemandFilter": "onDemandFilter"; }, {}, never, never, false>;
}
