import { OnInit, EventEmitter, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { UntypedFormGroup, UntypedFormBuilder, UntypedFormArray, UntypedFormControl, AbstractControl } from '@angular/forms';
import { MatSelectChange } from '@angular/material/select';
import { Observable } from 'rxjs';
import { DkConfig } from '../../grid/dk-config';
import { ColumnAlignment } from '../../columns/dk-column-def';
import { Condition } from '../dk-filter-types';
import { DkFilterBehaviour, DkTextFilter, DkTextFilterEmission } from '../dk-filter.model';
import { DkGridConfig } from '../../grid/dk-grid-config.service';
import * as i0 from "@angular/core";
export declare class DkTextFilterComponent<T extends object> implements OnInit, OnDestroy, DkFilterBehaviour<DkTextFilterEmission> {
    private dikeConfig;
    private textFilterDebounceTime;
    private cdr;
    private formBuilder;
    private gridConfig;
    contentAlign: ColumnAlignment;
    isFilterRow: boolean;
    appliedFilter: DkTextFilter[];
    isCaseSensitive: boolean;
    conditionTypes: Condition<T, string | null | undefined, DkTextFilter>[];
    onDemandFilter: boolean;
    clearRowFilterControl: Observable<void>;
    filterChange: EventEmitter<DkTextFilterEmission>;
    textFilterForm: UntypedFormGroup;
    matSelectPanelClass: string;
    private valueChangesSubscription;
    private clearFilterChangesSubscription;
    constructor(dikeConfig: DkConfig, textFilterDebounceTime: number, cdr: ChangeDetectorRef, formBuilder: UntypedFormBuilder, gridConfig: DkGridConfig);
    ngOnInit(): void;
    ngOnDestroy(): void;
    get conditions(): UntypedFormArray;
    get caseSensitive(): UntypedFormControl;
    addCondition(): void;
    removeCondition(indexGroup: number): void;
    clear(): void;
    applyFilter(): void;
    onLogicalOperatorChange(): void;
    onConditionTypeChange(event: MatSelectChange, conditionGroup: AbstractControl): void;
    onCaseSensitiveChange(): void;
    isFilterApplied(): boolean;
    private createForm;
    private createConditionGroup;
    private addValueControl;
    private emitValues;
    private setClearFilterChangesSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkTextFilterComponent<any>, [null, { optional: true; }, null, null, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkTextFilterComponent<any>, "dk-text-filter", never, { "contentAlign": "contentAlign"; "isFilterRow": "isFilterRow"; "appliedFilter": "appliedFilter"; "isCaseSensitive": "isCaseSensitive"; "conditionTypes": "conditionTypes"; "onDemandFilter": "onDemandFilter"; "clearRowFilterControl": "clearRowFilterControl"; }, {}, never, never, false>;
}
