import { OnDestroy, TemplateRef } from '@angular/core';
import { Observable } from 'rxjs';
import { DkConfig } from './dk-config';
import { DkColumnDataType } from '../columns/dk-column-def';
import { WaitingIndicatorNotifier } from './dk-grid.model';
import * as i0 from "@angular/core";
export declare class DkGridConfig implements OnDestroy {
    private dikeConfig;
    private gridCustomScrollbars;
    private loadingMessage;
    private processingMessage;
    private gridHeight;
    private gridWidth;
    private gridDivisionPanelLineWidth;
    private gridDivisionPanelLineWidthResizing;
    private gridDivisionPanelGap;
    private allowGridColumnContextMenu;
    private gridColumnContextMenuWidth;
    private gridColumnContextMenuHeight;
    private dikeGridId;
    private dikeTextDisplay;
    private dikeNumericDisplay;
    private dikeDateDisplay;
    private dikeBinaryDisplay;
    private allowColumnDraggingSubject;
    private allowColumnContextMenuSubject;
    private waitIndicatorSubject;
    private initializedSubject;
    constructor(dikeConfig: DkConfig, gridCustomScrollbars: boolean, loadingMessage: string, processingMessage: string, gridHeight: string, gridWidth: string, gridDivisionPanelLineWidth: number, gridDivisionPanelLineWidthResizing: number, gridDivisionPanelGap: number, allowGridColumnContextMenu: boolean, gridColumnContextMenuWidth: number, gridColumnContextMenuHeight: number);
    ngOnDestroy(): void;
    get onAllowColumnDraggingChanged$(): Observable<boolean>;
    get onAllowColumnContextMenuChanged$(): Observable<boolean>;
    get onWaitIndicatorChanged$(): Observable<WaitingIndicatorNotifier>;
    get onInitializedChanged$(): Observable<boolean>;
    get textDisplayTemplate(): TemplateRef<any>;
    set textDisplayTemplate(template: TemplateRef<any>);
    get numericDisplayTemplate(): TemplateRef<any>;
    set numericDisplayTemplate(template: TemplateRef<any>);
    get dateDisplayTemplate(): TemplateRef<any>;
    set dateDisplayTemplate(template: TemplateRef<any>);
    get binaryDisplayTemplate(): TemplateRef<any>;
    set binaryDisplayTemplate(template: TemplateRef<any>);
    get gridId(): string;
    set gridId(value: string);
    get height(): string;
    set height(value: string);
    get width(): string;
    set width(value: string);
    get allowColumnDragging(): boolean;
    set allowColumnDragging(value: boolean);
    get allowColumnContextMenu(): boolean;
    set allowColumnContextMenu(value: boolean);
    get divisionPanelLineWidth(): number;
    get divisionPanelLineWidthResizing(): number;
    get divisionPanelGap(): number;
    get columnContextMenuWidth(): number;
    get columnContextMenuHeight(): number;
    get customScrollbars(): boolean;
    get isWaitingIndicatorActive(): boolean;
    initialized(): void;
    isInitialized(): boolean;
    displayLoadingIndicator(): void;
    displayProcessingIndicator(): void;
    displayWaitingIndicator(message: string): void;
    hideWaitingIndicator(): void;
    getDefaultDisplayTemplate(columnDataType: DkColumnDataType): TemplateRef<any>;
    getCdkBufferPx(visiblecolumns: number): {
        minBufferPx: number;
        maxBufferPx: number;
    };
    private changeAllowColumnDragging;
    private changeAllowColumnContextMenu;
    private changeWaitingIndicator;
    private changeInitialized;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridConfig, [null, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }, { optional: true; }]>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridConfig>;
}
