import { OnInit } from '@angular/core';
import { CdkDragDrop, CdkDragEnd, CdkDragEnter, CdkDragExit, CdkDragStart } from '@angular/cdk/drag-drop';
import { Observable } from 'rxjs';
import { DraggableContainer, ShareableDropElements } from '../../common/dk-draggable-containers';
import { DkColumnMeshSlot, DkMeshSlot } from '../../columns/dk-column-mesh-slot';
import { DkGroupColumnStructure } from '../../columns/dk-group-column-structure';
import { DkGridBorder } from '../../grid/dk-grid.model';
import { DkGridPanel, DkGroupPanel } from '../../panels/dk-grid-panels';
import { DkGridStructure } from '../../grid/dk-grid-structure.service';
import { DkGeneralNotifier } from '../../common/dk-general-notifier.service';
import { DkGridPanelDispatcher } from '../../panels/dk-grid-panel-dispatcher.service';
import { DkGroupPanelDispatcher } from '../dk-group-panel-dispatcher.service';
import { DkGridConfig } from '../../grid/dk-grid-config.service';
import * as i0 from "@angular/core";
export declare class DkGridRowGroupingComponent<T extends object> implements OnInit {
    private gridConfig;
    private gridStructure;
    private groupPanelDispatcher;
    private gridPanelDispatcher;
    private generalNotifier;
    columnStructure: DkGroupColumnStructure<T>;
    panel: DkGroupPanel;
    borders: [DkGridBorder, DkGridBorder];
    shareables: Record<DkGridPanel, ShareableDropElements>;
    sourceContainer: DraggableContainer;
    dropSwapContainer: DraggableContainer;
    dropGutterContainer: DraggableContainer;
    visibleColumnSlots$: Observable<DkColumnMeshSlot[]>;
    rowGroupingColumnHeight$: Observable<string>;
    isDragging$: Observable<boolean>;
    allowColumnDragging$: Observable<boolean>;
    rowGroupingPanelId: string;
    constructor(gridConfig: DkGridConfig, gridStructure: DkGridStructure<T>, groupPanelDispatcher: DkGroupPanelDispatcher<T>, gridPanelDispatcher: DkGridPanelDispatcher<T>, generalNotifier: DkGeneralNotifier);
    ngOnInit(): void;
    noDroppingAllowed(): boolean;
    onDragStart(event: CdkDragStart): void;
    onDragEnd(event: CdkDragEnd): void;
    onDropListEntered(entered: CdkDragEnter<DkMeshSlot>): void;
    onDropListExited(exited: CdkDragExit<DkMeshSlot>): void;
    onDrop(dropped: CdkDragDrop<DkMeshSlot, DkColumnMeshSlot>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridRowGroupingComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkGridRowGroupingComponent<any>, "dk-grid-row-grouping", never, { "columnStructure": "columnStructure"; }, {}, never, never, false>;
}
