import { EventEmitter, OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { DkGroupRowCollapseEvent } from './dk-row-grouping.model';
import { DkDataColumnDef } from '../columns/dk-column-def';
import { DkGridGroupRowEntry, DkGridDataRowEntry } from '../rows/dk-grid-row-entry';
import { DkGroupPanelDispatcher } from './dk-group-panel-dispatcher.service';
import { DkGridFactoryColumns } from '../columns/dk-grid-factory-columns.service';
import * as i0 from "@angular/core";
export declare class DkRowGroupingDispatcher<T extends object> implements OnDestroy {
    private groupPanelDispatcher;
    private gridFactoryColumns;
    readonly collapseGroupRowEmitter: EventEmitter<DkGroupRowCollapseEvent<T>>;
    private groupPanelCardinalitySubject;
    private collapseGroupSubject;
    private rootGroupRowSubject;
    private changeGroupPanelCardinalitySubscription;
    constructor(groupPanelDispatcher: DkGroupPanelDispatcher<T>, gridFactoryColumns: DkGridFactoryColumns<T>);
    ngOnDestroy(): void;
    get onGroupPanelCardinalityChanged$(): Observable<number>;
    get onCollapseGroupChanged$(): Observable<DkGroupRowCollapseEvent<T>>;
    get onRootGroupRowChanged$(): Observable<DkGridGroupRowEntry<T>>;
    get groupPanelCardinality(): number;
    collapseGroup(group: DkGridGroupRowEntry<T>): void;
    isThereDeeperLevel(level: number): boolean;
    getGroupByColumn(level: number): DkDataColumnDef<T, string | number | Date | boolean | null | undefined>;
    createRowGroups(currentGroup: DkGridGroupRowEntry<T>): Map<unknown, DkGridDataRowEntry<T>[]>;
    get rootGroupRow(): DkGridGroupRowEntry<T>;
    set rootGroupRow(value: DkGridGroupRowEntry<T>);
    private setGroupPanelCardinalitySubscription;
    private changeCollapseGroup;
    private changeRootGroupRow;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkRowGroupingDispatcher<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkRowGroupingDispatcher<any>>;
}
