import { OnInit, OnDestroy, ChangeDetectorRef, SimpleChanges, OnChanges } from '@angular/core';
import { Observable } from 'rxjs';
import { DkColumnMeshSlot, DkGutterMeshSlot } from '../../columns/dk-column-mesh-slot';
import { DkContentColumnStructure } from '../../columns/dk-content-column-structure';
import { DkSlotPlacement } from '../../common/dk-slot-placement';
import { DkContentPanel } from '../../panels/dk-grid-panels';
import { DkGridDataRowEntry } from '../dk-grid-row-entry';
import { DkGridContentStructure } from '../../content/dk-grid-content-structure.service';
import { DkGridRowEditionDispatcher } from '../../editing/dk-grid-row-edition-dispatcher.service';
import { DkGridEditionConfig } from '../../editing/dk-grid-edition-config.service';
import * as i0 from "@angular/core";
export declare class DkGridRowComponent<T extends object> implements OnInit, OnChanges, OnDestroy {
    private cdr;
    private gridContentStructure;
    private gridEditionConfig;
    private rowEditionDispatcher;
    columnStructure: DkContentColumnStructure<T>;
    row: DkGridDataRowEntry<T>;
    sourceIndex: number;
    isVerticalLineVisible: boolean;
    panel: DkContentPanel;
    isThereOuterColumns: boolean;
    contentRowHeightPx: string;
    contentHorizontalGutterHeightPx: string;
    outerColumnSlots$: Observable<DkColumnMeshSlot[]>;
    visibleDataColumnSlots$: Observable<DkColumnMeshSlot[]>;
    horizontalGutterSlot$: Observable<DkSlotPlacement>;
    gutterSlotAction$: Observable<DkGutterMeshSlot>;
    rowTimestamp: number;
    isRowEditing: boolean;
    private unsubscribeAll;
    private changeTimestampSubscription;
    private changeRowEditingSubscription;
    constructor(cdr: ChangeDetectorRef, gridContentStructure: DkGridContentStructure<T>, gridEditionConfig: DkGridEditionConfig<T>, rowEditionDispatcher: DkGridRowEditionDispatcher<T>);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    private setChangeTimestampSubscription;
    private setChangeRowEditingSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridRowComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DkGridRowComponent<any>, "dk-grid-row", never, { "columnStructure": "columnStructure"; "row": "row"; "sourceIndex": "sourceIndex"; "isVerticalLineVisible": "isVerticalLineVisible"; }, {}, never, never, false>;
}
