import { OnDestroy } from "@angular/core";
import { Observable } from "rxjs";
import { DkDataColumnDef } from '../columns/dk-column-def';
import { DkGridColumnDef } from '../columns/dk-grid-column-def.service';
import { DkSortDispatcher } from "./dk-sort-dispatcher.service";
import * as i0 from "@angular/core";
export interface DkColumnSortEvent<T extends object> {
    type: 'asc' | 'desc';
    sortedColumn: DkDataColumnDef<T, string | number | Date | boolean | null | undefined>;
}
export declare class DkGridSorting<T extends object> implements OnDestroy {
    private sortDispatcher;
    private gridColumnDef;
    private changeDataSortSubscription;
    constructor(sortDispatcher: DkSortDispatcher<T>, gridColumnDef: DkGridColumnDef<T>);
    get sortChange(): Observable<DkColumnSortEvent<T>>;
    ngOnDestroy(): void;
    sortBy(column: DkDataColumnDef<T, string | number | Date | boolean | null | undefined>, direction: 'asc' | 'desc'): void;
    isDikeGridSortedBy(column: DkDataColumnDef<T, string | number | Date | boolean | null | undefined>): boolean;
    getCurrentSortable(): DkColumnSortEvent<T>;
    clearSorting(): void;
    private getCurrentDikeColumnSorted;
    private setChangeDataSortSubscription;
    static ɵfac: i0.ɵɵFactoryDeclaration<DkGridSorting<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DkGridSorting<any>>;
}
